"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _coreCombinators = require("./core-combinators");

var _utils = require("./utils");

exports.default = function () {
  var types = {},
      metadata = {};

  return {
    newType: function newType(name, definition, meta) {
      if (types[name]) throw new Error("Cannot redefine the existing type " + name);
      types[name] = (0, _utils.clone)(definition);
      metadata[name] = (0, _utils.clone)(meta) || {};
      return _coreCombinators.core.reference(name);
    },
    getTypes: function getTypes() {
      return (0, _utils.clone)(types);
    },
    getMetadata: function getMetadata() {
      return (0, _utils.clone)(metadata);
    }
  };
};